//
//  ViewController.swift
//  TraknPay-Swift
//
//  Created by ​Senthil Kumar ​Selvaraj on 11/21/20.
//

import UIKit
import TraknPaySwift
import WebKit

class ViewController: UIViewController {
    
    @IBOutlet weak var responseTextView: UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
}

extension ViewController{
    
    @IBAction func payBittonPressed(){
        
        let params = TraknPayParams(
            
            apiKey: SampleAppConstant.API_KEY,
            
            orderId: SampleAppConstant.ORDER_ID,
                                    
            hash: SampleAppConstant.HASH,
                                    
            mode: SampleAppConstant.MODE,
                                    
            amount: SampleAppConstant.AMOUNT,
                                    
            name: SampleAppConstant.NAME,
                                    
            phone: SampleAppConstant.PHONE,
                                    
            email: SampleAppConstant.EMAIL,
                                    
            returnURL: SampleAppConstant.RETURN_URL,
                                    
            description: SampleAppConstant.DESCRIPTION,
                                    
            currency: SampleAppConstant.CURRENCY,
                                   
            country: SampleAppConstant.COUNTRY,
                                    
            city: SampleAppConstant.CITY,
                                    
            state: SampleAppConstant.STATE,
                                    
            addressLine1: SampleAppConstant.ADD_1,
                                    
            addressLine2: SampleAppConstant.ADD_2,
                                    
            udf1: SampleAppConstant.UDF_1,
                                    
            udf2: SampleAppConstant.UDF_2,
                                    
            udf3: SampleAppConstant.UDF_3,
                                    
            udf4: SampleAppConstant.UDF_4,
                                    
            udf5: SampleAppConstant.UDF_5,
                                    
            zipCode: SampleAppConstant.ZIP_CODE)
        
        
        /// This is the alternate way to define all those params

        //        var params1 = TraknPayParams()
        //        params1.timeout_duration = "20"
        //        params1.api_key = "xxxx-xxxx-xx-xxxxx"
        //        params1.enable_auto_refund = "n"
        
      
        /// This is line trigger the payment screen
        /// Please make sure that delegate values send to this contaoller
        TraknPay.presentTraknPayContorller(controller: self, params: params, delegate: self)
       
        /// This is for merchant
        TraknPay.presentTraknPayContorller(controller: self, url: "https://merchant.com", params: params, delegate: self)
        
        
    }
}


extension ViewController: TraknPayDelegate{
    
    ///
    /// This is the main deleagte method that provides the conteollet object and data (String)
    ///
    
    func didPaymentCompleted(_ controller: UIViewController, data: Any?) {
        if let jsonString = data as? String, let response = jsonString.toJSONDictionary{
            if let statusCode = response.value(forKey: "response_code") as? Int, statusCode == 0{
                // Successs
                print("Success")
                responseTextView.text = jsonString
                print(response.value(forKey: "transaction_id"))
            }else{
                // Failure
                print("Failure")
            }
        }
        controller.dismiss(animated: true, completion: nil)
    }
    
    ///
    /// This method indicates to cancel the payment screen
    ///
    
    func didPaymentCanceled(_ controller: UIViewController) {
        controller.dismiss(animated: true, completion: nil)
    }
}


/// SampleConstant things


struct SampleAppConstant {
    // API Key that is provided by TraknPay Payament Portal.
    static let API_KEY = "XXXXXX-XXXXXXXXX-XXXXXXXX-XXXXX"
    
    // Specify the clients web server url to catch the payemnt response
    static let RETURN_URL = "http://xxxxx.xxxxxx.xxx/xxxxxx"
    
    // Specify the Payamnet Mode. 1. TEST - Sandbox Mode 2. LIVE - Need to speicfy this one while go LIVE
    static let MODE = "TEST"
    
    // Specify the Currency value. Only allowed INR
    static let CURRENCY = "INR"
    
    // Specify the Country code. Only allowed IND
    static let COUNTRY = "IND"
    
    /// Update your server generated HASH Key
    static let HASH = "XXXXXXXXXXXXXXXXXX"
    
    // Order ID
    static let ORDER_ID = "2009"
    static let AMOUNT = "2.00"
    static let NAME = "Senthil"
    static let EMAIL = "sample@sample.com"
    static let PHONE = "1234567890"
    static let DESCRIPTION = "Product info"
    static let CITY = "Bangalore"
    static let STATE = "Karnataka"
    static let ADD_1 = "Add 1"
    static let ADD_2 = "Add 2"
    static let ZIP_CODE = "560053"
    static let UDF_1 = ""
    static let UDF_2 = ""
    static let UDF_3 = ""
    static let UDF_4 = ""
    static let UDF_5 = ""
}

extension String{
    var toJSONDictionary: NSDictionary?{
        
        guard let data = self.data(using: .utf8) else {
            return nil
        }
        
        return try? JSONSerialization.jsonObject(with: data, options: []) as? NSDictionary
    
    }
}


